package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.BGYP;
import com.sa.ibiz.demo.demo.service.BGYPService;
import com.sa.ibiz.demo.demo.service.dto.BGYPSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/bgyp")
public class BGYPResource
{
	@Autowired
	private BGYPService service;


	@GetMapping(value = "/{id}")
	public ResponseEntity<BGYP> get(@Validated @PathVariable String id){
		BGYP data=new BGYP();
		data.setBgypid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("办公用品[get]操作发生错误","BGYP",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<BGYP> remove(@Validated @RequestBody BGYP data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("办公用品[remove]操作发生错误","BGYP",data.getBgypid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<BGYP> update(@Validated @RequestBody BGYP data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("办公用品[update]操作发生错误","BGYP",data.getBgypid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<BGYP> checkKey(@Validated @RequestBody BGYP data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("办公用品[checkKey]操作发生错误","BGYP",data.getBgypid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<BGYP> create(@Validated @RequestBody BGYP data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("办公用品[create]操作发生错误","BGYP",data.getBgypid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<BGYP> getDraft(@Validated @RequestBody BGYP data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("办公用品[getDraft]操作发生错误","BGYP","");
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<BGYP>> searchDefaultPage(@Validated @RequestBody BGYPSearchFilter filter){
		Page<BGYP> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<BGYP>> listDefault(@Validated @RequestBody BGYPSearchFilter filter){
		List<BGYP> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
